#include <AI8051U.H>
#include "./User_Timer.h"
#include "./User_UART.h"
#include "./User_DMA.h"
#include "./User_Sys.h"
#include "./User_USB.h"
#include "./stc32_stc8_usb.h"
#include "./User_Config.h"
#include "intrins.h"
#include "stdio.h"
#include "string.h"

//DMA
bit DMATxFlag;//DMA1ͱ־
bit DMARxFlag;//DMA1ձ־
u8 xdata DMABuffer[DMA_AMT_LEN+1];
u16 DMA_Transmit_Size;//DMAѾɹֽ

//DMAʼ
void DMA_Tag_Init()
{
	DMATxFlag=0;//DMA1ͱ־
	DMARxFlag=0;//DMA1ձ־
	DMA_Transmit_Size=0;//DMAѾɹֽ
}

//DMAݸʽ
void DMA_Data_Refresh()
{
	volatile uint i;//ֽڸ
	
	for(i=0;i< DMA_AMT_LEN+1;i++)//256
	{
		DMABuffer[i]=i;//0X00-0XFFװؽDMABuffer
	}
}

//DMAú
void DMA_Config()
{
	DMA_UR1T_CFG=0X80;//DMA-UART1ж
	DMA_UR1T_STA=0X00;//жλ,Ҫ
	DMA_UR1T_AMT=DMA_AMT_LEN;//ôֽ,N+1
	DMA_UR1T_AMTH=DMA_AMT_LEN>>8;//ôֽ,N+1
  DMA_UR1T_TXAH =((u16)&DMABuffer >> 8);
  DMA_UR1T_TXAL =((u16)&DMABuffer);
	DMA_UR1T_CR=0X80;//ʹDMA-UART1
	
	DMA_UR1R_CFG=0X80;//DMA-UART1ж
	DMA_UR1R_STA=0X00;//жϱ־ͽݶ־λ
	DMA_UR1R_AMT=DMA_AMT_LEN;//ôֽ,N+1
	DMA_UR1R_AMTH=DMA_AMT_LEN>>8;//ôֽ,N+1
	DMA_UR1R_RXAH = (u8)((u16)&DMABuffer >> 8);//дԴַ,ڴ˵ַȡ
  DMA_UR1R_RXAL = (u8)((u16)&DMABuffer);//дԴַ,ڴ˵ַ
	DMA_UR1R_CR=0XA1;//ʹDMA-UART1,ʼԶ,FIFO
	
	EA=1;//ж
}

/*ע:DMA_UART1ɺ,DMA_UR1T_DONEĴᱻӲ
	㣬ܹ,Ҫ,ҪصDMAܼ,ʵʲӰ*/

//DMA-UART1_TжϷ
void UART1_DMA_Isr() interrupt 50
{
	if(DMA_UR1T_STA&0X01)//DMA_UART1ж
	{
		DMA_UR1T_STA &=~0x01;//жϱ־λ
		DMATxFlag=1;//DMA_UART1ͱ־λһ
		P40=0;
		P01=!P01;
	}
	
	if(DMA_UR1T_STA&0X04)//DMA_UART1ݸж
	{
		DMA_UR1T_STA&=~0X04;//жϱ־λ
	}
	
}

/*ע:DMA_UART1ɺ,DMA_UR1R_DONEĴᱻӲ
	㣬ܹ,Ҫ,ҪصDMAܼ,ʵʲӰ*/

//DMA_UART1_RжϷ
void DMA_UART1_R_Isr() interrupt 51
{
	if(DMA_UR1R_STA&0X01)//ж
	{
		DMARxFlag=1;//DMAձ־λһ
		P40=0;
		P02=!P02;		
		DMA_UR1R_STA&=~0X01;//ж
	}
	
	if(DMA_UR1R_STA&0X02)//ݶж
	{
		DMA_UR1R_STA&=~0X02;//ݶжϱ־λ
	}	
}

//DMA_UART1ʱ⺯
void DMA_UART1_Time_Over()
{
	if(B_RX1_TimeOut==1)//ڽճʱ
	{
		B_RX1_TimeOut=0;//ʱ
		
	/*******************************************************
	DMAPC˷͵MCUϢԭ·,浽ָԴַУ
	********************************************************/
		/***ȼDMAյֽڴС,ȻDMA_UR1R_AMTĴ***/
		DMA_Transmit_Size=((u16)(DMA_UR1R_DONEH<<8)+(u8)DMA_UR1R_DONE-1);//ɹյֽ
		DMA_UR1T_AMTH=(u8)(DMA_Transmit_Size>>8);//ôֽ,N+1	
		DMA_UR1T_AMT=(u8)(DMA_Transmit_Size);//ôֽ,N+1
		
		/***ȹرDMAԶչ,DMAԶ͹,ܼյֽ,
				DMAɽպ,ԶDMA_UR1R_DONEĴȫ,ӡԶ0***/
		DMA_UR1R_CR=0;//DMA_UART1չܹر,ͻDMA_UR1R_DONE!!!
		
		/***յֽӡڴ,DMAյݻͨDMAĴڷͳȥ***/
		printf("\r\n Total_Size:%u \r\n",DMA_Transmit_Size+1);//ӡDMAɹֽ
		
		/***DMAԶչ,ҿDMAԶ͹,յݷͳȥ***/
		DMA_UR1T_CR=0XC0;//ʹDMA-UART1,ʼԶ	
		DMA_UR1R_CR=0XA1;//ʹDMA-UART1,ʼԶ,FIFO	
		
	}			
			
}